/* Poniszy kod pochodzi z ksiki
* "C++. Programowanie zorientowane obiektowo.
* Vademecum profesjonalisty"
* autorstwa Nicolai M. Josuttisa, wydanej
* w Polsce przez wydawnictwo HELION S.A. w 2003 roku
* (wydanie oryginalne: Wiley, 2002)
*
* (C) Copyright Nicolai M. Josuttis 2002.
* Kopiowanie, wykorzystywanie, modyfikacja
* i rozpowszechnianie niniejszego oprogramowania
* jest dozwolone pod warunkiem zamieszczenia
* niniejszej informacji o prawach autorskich.
* Oprogramowanie to jest udostpniane
* bez jakichkolwiek gwarancji.
*/

#ifndef FRACTION_HPP
#define FRACTION_HPP

// **** Pocztek przestrzeni nazw CPPBook ********************************
namespace CPPBook {

/* klasa Fraction
 */
class Fraction {
  /* private: bez dostpu z zewntrz
   */
  private:
    int numer;
    int denom;

  /* publicznie dostpny interfejs
   */
  public:
    // domylny konstruktor
    Fraction();

    // konstruktor o jednym parametrze typu int (mianownik)
    Fraction(int);

    // konstruktor o dwch parametrach typu int (licznik i mianownik)
    Fraction(int, int);

    // wywietlanie
    void print();

    // nowe: mnoenie z innym uamkiem
    Fraction operator * (Fraction);

    // nowe: przypisanie z mnoeniem
    Fraction operator *= (Fraction);

    // new: porwnanie z innym uamkiem
    bool operator < (Fraction);
};

} // **** Koniec przestrzeni nazw CPPBook ********************************

#endif    // FRACTION_HPP

