/* Poniszy kod pochodzi z ksiki
* "C++. Programowanie zorientowane obiektowo.
* Vademecum profesjonalisty"
* autorstwa Nicolai M. Josuttisa, wydanej
* w Polsce przez wydawnictwo HELION S.A. w 2003 roku
* (wydanie oryginalne: Wiley, 2002)
*
* (C) Copyright Nicolai M. Josuttis 2002.
* Kopiowanie, wykorzystywanie, modyfikacja
* i rozpowszechnianie niniejszego oprogramowania
* jest dozwolone pod warunkiem zamieszczenia
* niniejszej informacji o prawach autorskich.
* Oprogramowanie to jest udostpniane
* bez jakichkolwiek gwarancji.
*/

#include "vehiclehier.hpp"
#include <iostream>

int main()
{
    using std::cout;
    using std::endl;

    CPPBook::Amph a;

    // adres obiektu  a
    cout << "&a: " << (void*)&a << "\n" << endl;

    // adres obiektu  a => jako obiektu Car i Boat
    cout << "(CPPBook::Car*) &a: "
         << (void*)(CPPBook::Car*)&a << "\n";
    cout << "(CPPBook::Boat*) &a: "
         << (void*)(CPPBook::Boat*)&a << "\n\n";

    // adres obiektu  a => jako obiektu Car => jako obiektu Vehicle
    cout << "(CPPBook::Vehicle*) (CPPBook::Car*) &a: "
         << (void*)(CPPBook::Vehicle*)(CPPBook::Car*)&a << endl;

    // adres obiektu  a => jako obiektu Boat => jako obiektu Vehicle
    cout << "(CPPBook::Vehicle*) (CPPBook::Boat*) &a: "
         << (void*)(CPPBook::Vehicle*)(CPPBook::Boat*)&a << endl;
}

